/*
         xdipo copyright Jan Panteltje 2005 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

                                  /* SET TABS TO 4 TO READ THIS SOURCE */


#include "xdipo.h"

FD_xdipo *fdui;


FD_xdipo *create_form_main_form(void)
{
FL_OBJECT *obj;

fdui = (FD_xdipo *) fl_calloc(1, sizeof(*fdui));

fl_set_idle_callback(idle_cb, 0);

fdui -> timer_form =\
fl_bgn_form(FL_UP_BOX, 700, 500);

fdui -> timer_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 4, 350, 25,\
	"R E C O R D I N G  T I M E R S");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);

fdui -> timer_form_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 20, 28, 558, 200, "");
	fl_set_object_color(obj, FL_WHITE, 15);
/* does not seem to have any effct what fontstyle you select */
//	fl_set_browser_fontstyle(obj, 15);
	fl_set_object_callback(obj, timer_form_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, timer_form_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);

fdui -> timer_form_length_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 345, 390, 80, 25, "length");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_length_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_directory_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 240, 558, 25, "directory");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_directory_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_filename_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 20, 290, 558, 25, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> timer_form_filename_output_field_text = obj =\
	fl_add_box(FL_NO_BOX, 20, 315, 558, 25, "filename");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);

fdui -> timer_form_start_text_field = obj =\
	fl_add_box(FL_NO_BOX, 20, 340, 40, 25, "START");
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);

fdui -> timer_form_start_year_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 65, 340, 50, 25, "year");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_start_year_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_start_month_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 125, 340, 40, 25, "month");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_start_month_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);	

fdui -> timer_form_start_day_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 175, 340, 40, 25, "day");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_start_day_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);

fdui -> timer_form_start_hour_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 225, 340, 40, 25, "hour");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_start_hour_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_start_minute_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 275, 340, 40, 25, "minute");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_start_minute_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_start_weekday_output_field_text = obj =\
	fl_add_box(FL_DOWN_BOX, 335, 340, 100, 25, "");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lcol(obj, FL_BLACK);
	fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> timer_form_start_weekday_output_field_text_text = obj =\
	fl_add_box(FL_NO_BOX, 340, 362, 90, 25, "when");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);

fdui -> timer_form_stop_text_field = obj =\
	fl_add_box(FL_NO_BOX, 20, 390, 40, 25, "STOP");
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);

fdui -> timer_form_stop_year_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 65, 390, 50, 25, "year");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_stop_year_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_stop_month_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 125, 390, 40, 25, "month");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_stop_month_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_stop_day_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 175, 390, 40, 25, "day");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_stop_day_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_stop_hour_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 225, 390, 40, 25, "hour");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_stop_hour_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_stop_minute_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 275, 390, 40, 25, "minute");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, timer_form_stop_minute_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_BOTTOM);
	
fdui -> timer_form_showview_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 485, 340, 90, 25, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> timer_form_showview_output_field_text = obj =\
	fl_add_box(FL_NO_BOX, 485, 362, 90, 25, "showview");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);

fdui -> timer_form_daily_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 590, 50, 90, 30, "DAILY");
	fl_set_object_callback(obj, timer_form_daily_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> timer_form_work_days_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 590, 100, 90, 30, "WORK DAYS");
	fl_set_object_callback(obj, timer_form_work_days_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, 10); // mat blue

fdui -> timer_form_weekly_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 590, 150, 90, 30, "WEEKLY");
	fl_set_object_callback(obj, timer_form_weekly_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_CYAN);

fdui -> timer_form_delete_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 290, 90, 30, "DELETE");
	fl_set_object_callback(obj, timer_form_delete_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> timer_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 460, 90, 30, "CANCEL");
	fl_set_object_callback(obj, timer_form_cancel_button_cb, 0);

fdui -> timer_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 460, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, timer_form_accept_button_cb, 0);
	
fdui -> timer_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 500, 460, 20, 20, "-");
	fl_set_object_callback(obj, timer_form_fontsize_down_button_cb, 0);

fdui -> timer_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 530, 460, 20, 20, "+");
	fl_set_object_callback(obj, timer_form_fontsize_up_button_cb, 0);

fl_end_form(); /* timer_form */



fdui -> installer_commands_form =\
fl_bgn_form(FL_UP_BOX, 400, 300);

fdui -> installer_commands_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 10, 5, 380, 30,\
	"I N S T A L L E R  C O M M A N D S");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> installer_commands_form_satellite_number_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 100, 40, 50, 30, "Sat");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, installer_commands_form_satellite_number_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 4);
	fl_set_input(obj, "0");

fdui -> installer_commands_form_recalculate_param1_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 190, 40, 50, 30, "P1");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, installer_commands_form_recalculate_param1_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 4);
	fl_set_input(obj, "0");

fdui -> installer_commands_form_recalculate_param2_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 280, 40, 50, 30, "P2");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, installer_commands_form_recalculate_param2_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 4);
	fl_set_input(obj, "0");

fdui -> installer_commands_form_recalculate_positions_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 40, 80, 30, "RECALCULATE\nPOSITIONS");
	fl_set_object_callback(obj, installer_commands_form_recalculate_positions_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> installer_commands_form_start_motor_driving_east_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 145, 135, 30, 30, "@<");
	fl_set_object_callback(obj, installer_commands_form_start_motor_driving_east_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_shortcut(obj, "Ee", 1);

fdui -> installer_commands_form_halt_motor_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 185, 135, 30, 30, "H");
	fl_set_object_callback(obj, installer_commands_form_halt_motor_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_shortcut(obj, "Hh", 1);

fdui -> installer_commands_form_start_motor_driving_west_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 225, 135, 30, 30, "@>");
	fl_set_object_callback(obj, installer_commands_form_start_motor_driving_west_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_shortcut(obj, "Ww", 1);

fdui -> installer_commands_form_set_west_limit_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 225, 175, 80, 30, "SET WEST\nLIMIT");
	fl_set_object_callback(obj, installer_commands_form_set_west_limit_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> installer_commands_form_disable_limits_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 115, 80, 80, 30, "DISABLE\nLIMITS");
	fl_set_object_callback(obj, installer_commands_form_disable_limits_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> installer_commands_form_set_east_limit_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 95, 175, 80, 30, "SET EAST\nLIMIT");
	fl_set_object_callback(obj, installer_commands_form_set_east_limit_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> installer_commands_form_goto_reference_position_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 160, 225, 80, 30, "GOTO\nREF");
	fl_set_object_callback(obj, installer_commands_form_goto_reference_position_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> installer_commands_form_enable_limits_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 210, 80, 80, 30, "ENABLE\nLIMITS");
	fl_set_object_callback(obj, installer_commands_form_enable_limits_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> installer_commands_form_close_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 310, 260, 80, 30, "CLOSE");
	fl_set_object_callback(obj, installer_commands_form_close_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

fl_end_form(); /* installer_commands_form */




fdui -> main_form =\
	fl_bgn_form(FL_NO_BOX, 600, 450);
	obj = fl_add_box(FL_UP_BOX, 0, 0, 600, 450,"");
	fl_set_object_lsize(obj,FL_HUGE_SIZE);
	fl_set_object_lstyle(obj,FL_FIXEDBOLDITALIC_STYLE + FL_EMBOSSED_STYLE);

fdui -> main_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 110, 5, 380, 30,\
	"PANTELTJE(c) DISEQC-1.2 SATELLITE DISH POSITIONER");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);

fdui -> main_form_recorder_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 10, 10, 90, 20, "RECORDER");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_recorder_menu_cb, 0);
	fl_set_menu(obj,\
"TIMERS\
");

fdui -> main_form_angle_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 10, 40, 70, 30, "angle"); //\neast/west");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_angle_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

/*
fdui -> main_form_angle_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 90, 70, 20, 20, "<");
	fl_set_object_callback(obj, main_form_angle_down_button_cb, 0);

fdui -> main_form_angle_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 120, 70, 20, 20, ">");
	fl_set_object_callback(obj, main_form_angle_up_button_cb, 0);
*/

fdui -> main_form_angle_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 72, 20, 20, "<");
	fl_set_object_callback(obj, main_form_angle_down_button_cb, 0);

fdui -> main_form_angle_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 50, 72, 20, 20, ">");
	fl_set_object_callback(obj, main_form_angle_up_button_cb, 0);

fdui -> main_form_search_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 90, 75, 110, 25, "");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_search_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "");

fdui -> main_form_case_sensitive_button = obj = \
	fl_add_button(FL_PUSH_BUTTON, 210, 75, 60, 25, "Case sens");
	fl_set_object_callback(obj, main_form_case_sensitive_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_search_button = obj = \
	fl_add_button(FL_NORMAL_BUTTON, 280, 75, 60, 25, "Search");
	fl_set_object_callback(obj, main_form_search_button_cb, 0);

fdui -> main_form_frequency_input_field = obj =\
	fl_add_input(FL_FLOAT_INPUT, 160, 40, 80, 30, "f");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_frequency_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

fdui -> main_form_polarization_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 270, 40, 30, 30, "pol");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_polarization_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 1);
	fl_set_input(obj, "0");

fdui -> main_form_symbolrate_input_field = obj =\
	fl_add_input(FL_INT_INPUT, 330, 40, 60, 30, "symbol\nrate");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_symbolrate_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

fdui -> main_form_stream_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 10, 103, 260, 100, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, main_form_stream_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, main_form_stream_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);
	fl_set_browser_fontsize(obj, FL_TINY_SIZE); 

fdui -> main_form_add_stream_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 205, 30, 20, "Add");
	fl_set_object_callback(obj, main_form_add_stream_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_delete_stream_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 52, 205, 30, 20, "Del");
	fl_set_object_callback(obj, main_form_delete_stream_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> main_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 100, 205, 20, 20, "-");
	fl_set_object_callback(obj, main_form_fontsize_down_button_cb, 0);

fdui -> main_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 130, 205, 20, 20, "+");
	fl_set_object_callback(obj, main_form_fontsize_up_button_cb, 0);

fdui -> main_form_satellite_number_input_field = obj =\
	fl_add_input(FL_INT_INPUT, 285, 210, 30, 30, "Sat");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_satellite_number_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_TOP);
	fl_set_input_maxchars(obj, 2);
	fl_set_input(obj, "0");

fdui -> main_form_step_value_input_field = obj =\
	fl_add_input(FL_INT_INPUT, 280, 115, 40, 30, "stepsize");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_step_value_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 3);
	fl_set_input(obj, "0");

fdui -> main_form_installer_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 510, 180, 80, 30, "Installer\ncommands");
	fl_set_object_callback(obj, main_form_installer_button_cb, 0);
	fl_set_object_color(obj, FL_DIAL_COL1, FL_DARKORANGE);

fdui -> main_form_nudge_motor_west_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 325, 210, 30, 30, "@>");
	fl_set_object_callback(obj, main_form_nudge_motor_west_button_cb, 0);
	fl_set_object_shortcut(obj, "[{", 1);

fdui -> main_form_nudge_motor_east_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 245, 210, 30, 30, "@<");
	fl_set_object_callback(obj, main_form_nudge_motor_east_button_cb, 0);
	fl_set_object_shortcut(obj, "]}", 1);

fdui -> main_form_nudge_tilt_motor_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 285, 155, 30, 30, "^");
	fl_set_object_callback(obj, main_form_nudge_tilt_motor_up_button_cb, 0);

fdui -> main_form_nudge_tilt_motor_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 285, 265, 30, 30, "v");
	fl_set_object_callback(obj, main_form_nudge_tilt_motor_down_button_cb, 0);

fdui -> main_form_east_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 210, 300, 80, 20, "east");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);

fdui -> main_form_west_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 310, 300, 80, 20, "west");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);

fdui -> main_form_increase_nudge_size_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 365, 210, 30, 30, "@>>");
	fl_set_object_callback(obj, main_form_increase_nudge_size_button_cb, 0);

fdui -> main_form_decrease_nudge_size_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 205, 210, 30, 30, "@<<");
	fl_set_object_callback(obj, main_form_decrease_nudge_size_button_cb, 0);

fdui -> main_form_toggle_step_timed_mode_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 10, 260, 80, 30, "TIME\nMODE");
	fl_set_object_callback(obj, main_form_toggle_step_timed_mode_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_hide_object(obj);

fdui -> main_form_toggle_goto_angle_sattelite_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 10, 410, 80, 30, "ANGLE\nSAT NR");
	fl_set_object_callback(obj, main_form_toggle_goto_angle_sattelite_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_store_present_satellite_number_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 210, 410, 80, 30, "STORE");
	fl_set_object_callback(obj, main_form_store_present_satellite_number_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> main_form_goto_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 310, 410, 80, 30, "GOTO\nANGLE");
	fl_set_object_callback(obj, main_form_goto_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_increment_satellite_number_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 405, 210, 30, 30, "+");
	fl_set_object_callback(obj, main_form_increment_satellite_number_button_cb, 0);

fdui -> main_form_decrement_satellite_number_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 165, 210, 30, 30, "-");
	fl_set_object_callback(obj, main_form_decrement_satellite_number_button_cb, 0);

fdui -> main_form_bit_error_rate_text_field = obj =\
	fl_add_box(FL_DOWN_BOX, 535, 30, 45, 20, "");

fdui -> main_form_bit_error_rate_text_text_field = obj =\
	fl_add_box(FL_NO_BOX, 490, 30, 45, 20, "bit errors");

fdui -> main_form_signal_strength_indicator = obj =\
	fl_add_dial(FL_FILL_DIAL, 485, 50, 60, 60, "S/N ratio");
	fl_set_object_callback(obj, main_form_signal_strength_indicator_cb, 0);
    fl_set_dial_bounds(obj, 0.0, 1.0); //MAX_SNR_SCALE);
    fl_set_dial_value(obj, 0.0);
    fl_set_object_color(obj, FL_DIAL_COL1, FL_GREEN);

fdui -> main_form_signal_strength_text_field = obj =\
	fl_add_box(FL_DOWN_BOX, 555, 65, 25, 25, "");

fdui -> main_form_signal_strength_text_text_field = obj =\
	fl_add_box(FL_NO_BOX, 585, 65, 10, 25, "dB");

fdui -> main_form_signal_strength_slider = obj =\
	fl_add_slider(FL_VERT_FILL_SLIDER, 450, 75, 20, 55, "sig");
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_slider_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_color(obj, FL_BLACK, FL_GREEN);
	fl_set_object_callback(obj, main_form_signal_strength_slider_cb, 0);
	fl_set_slider_bounds(obj, 1.0, 0.0);
	fl_set_slider_precision(obj, 0);

fdui -> main_form_carrier_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 470, 140, 20, 20, "C");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_RED, FL_GREEN);
//	fl_set_object_lalign(obj, FL_ALIGN_LEFT);

fdui -> main_form_viterbi_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 500, 140, 20, 20, "V");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_RED, FL_GREEN);
//	fl_set_object_lalign(obj, FL_ALIGN_LEFT);

fdui -> main_form_sync_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 530, 140, 20, 20, "S");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_RED, FL_GREEN);
//	fl_set_object_lalign(obj, FL_ALIGN_LEFT);

fdui -> main_form_lock_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 560, 140, 20, 20, "L");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_RED, FL_GREEN);
//	fl_set_object_lalign(obj, FL_ALIGN_LEFT);

fdui -> main_form_beep_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 545, 100, 35, 20, "BEEP");
	fl_set_object_callback(obj, main_form_beep_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_elevation_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 325, 155, 70, 30, "");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_YELLOW, FL_COL1);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
           
fdui -> main_form_elevation_output_field_text =\
	obj = fl_add_text(FL_NORMAL_TEXT, 397, 155, 70, 30, "elevation");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
           
fdui -> main_form_satellite_name_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 10, 250, 140, 30, "satellite name");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_satellite_name_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 39);
	fl_set_input(obj, "");

fdui -> main_form_satellite_location_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 10, 290, 70, 30, "satellite location");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_satellite_location_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

fdui -> main_form_longitude_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 10, 330, 70, 30, "longitude");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_longitude_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

fdui -> main_form_latitude_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 10, 370, 70, 30, "latitude");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_latitude_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "0");

fdui -> main_form_local_clock  =\
	obj = fl_add_clock(FL_DIGITAL_CLOCK, 165, 370, 90, 30, "");
    fl_set_object_boxtype(obj, FL_DOWN_BOX);
	fl_set_object_color(obj, FL_BLACK, FL_GREEN);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_LARGE_SIZE);

fdui -> main_form_command_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 265, 370, 275, 30, "");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_YELLOW, FL_COL1);
	fl_set_object_lalign(obj, FL_ALIGN_LEFT);
           
fdui -> main_form_elevation_output_field_text =\
	obj = fl_add_text(FL_NORMAL_TEXT, 540, 370, 50, 30, "status");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
           
fdui -> main_form_output_filename_output_field =\
	obj = fl_add_text(FL_NORMAL_TEXT, 170, 330, 265, 30, ""); // was 235 h
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_YELLOW, FL_COL1);
	fl_set_object_lalign(obj, FL_ALIGN_LEFT);

fdui -> main_form_output_filename_output_field_text =\
	obj = fl_add_text(FL_NORMAL_TEXT, 440, 330, 65, 35, "output\nfilename");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
           
fdui -> main_form_pids_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT,  330, 250, 230, 30, "PIDs");
//	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_pids_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input_maxchars(obj, 79);
	fl_set_input(obj, "8192");

fdui -> main_form_bitrate_output_field_text = obj =\
	fl_add_box(FL_NO_BOX, 520, 220, 50, 20, "kbps total");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);

fdui -> main_form_bitrate_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 455, 220, 50, 20, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_YELLOW, FL_COL1);

fdui -> main_form_seek_slider = obj =\
	fl_add_slider(FL_HOR_FILL_SLIDER, 510, 290, 80, 15, "disk space");
	fl_set_slider_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_color(obj, FL_GREEN, FL_COL1);
//	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_LEFT); 
	fl_set_object_callback(obj, main_form_seek_slider_cb, 0);

fdui -> main_form_record_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 510, 330, 80, 30, "RECORD");
	fl_set_object_callback(obj, main_form_record_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_exit_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 510, 410, 80, 30, "EXIT");
   	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_callback(obj, main_form_exit_switch_cb, 0);

/* Note: any data aquisition functions can be called from this callback */
/*
fl_add_signal_callback(\
	SIGALRM, (FL_SIGNAL_HANDLER)print_new_york_time, &mydata);
alarm(1);
*/

/*
fdui -> io_callback =\
	obj = fl_add_io_callback(fileno(filefd), FL_READ, io_cb, void *data)
*/

fl_end_form(); /* main form */


return fdui;
} /* end function FD_xdipo *create_form_main_form */

