/*
         xdipo copyright Jan Panteltje 2005 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


                                  /* SET TABS TO 4 TO READ THIS SOURCE */


#include "xdipo.h"

FD_xdipo *fdui;


void installer_commands_form_satellite_number_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;
char temp[80];

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &satellite_number);

sprintf(temp, "%d", satellite_number);
fl_set_input(fdui -> main_form_satellite_number_input_field, temp);

} /* end function installer_commands_form_satellite_number_input_field_cb */



void installer_commands_form_recalculate_param1_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &commands_form_recalculate_param1);

} /* end function installer_commands_form_recalculate_param1_input_field_cb */



void installer_commands_form_recalculate_param2_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *) fl_get_input(ob);
if(! ptr) return;

sscanf(ptr, "%i", &commands_form_recalculate_param2);

} /* end function installer_commands_form_recalculate_param2_input_field_cb */



void installer_commands_form_recalculate_positions_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x6f, 0x00, 0x00, 0x00};

if(! fl_show_question("Recalculate all positons?", 0) ) return; /* mouse on NO */

temp[3] = satellite_number;
temp[4] = commands_form_recalculate_param1;
temp[5] = commands_form_recalculate_param2;

send_diseqc_command(temp, 6);

} /* end function installer_commands_form_recalculate_positions_button_cb */


void installer_commands_form_start_motor_driving_west_button_cb(FL_OBJECT *ob, long data)
{
/* this is handled in idle_cb */
} /* end function installer_commands_form_start_motor_driving_west_button_cb */


void installer_commands_form_halt_motor_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x60};

send_diseqc_command(temp, 3);

} /* end function installer_commands_form_halt_motor_button_cb */


void installer_commands_form_start_motor_driving_east_button_cb(FL_OBJECT *ob, long data)
{
/* this is handled in idle_cb */
} /* end function installer_commands_form_start_motor_driving_east_button_cb */


void installer_commands_form_set_west_limit_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x67};

send_diseqc_command(temp, 3);

} /* end function installer_commands_form_set_west_limit_button_cb */


void installer_commands_form_disable_limits_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x63};

send_diseqc_command(temp, 3);

} /* end function installer_commands_form_disable_limits_button_cb */


void installer_commands_form_set_east_limit_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x66};

send_diseqc_command(temp, 3);

} /* end function installer_commands_form_set_east_limit_button_cb */


void installer_commands_form_goto_reference_position_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x6b, 0x00};

send_diseqc_command(temp, 4);

} /* end function installer_commands_form_goto_reference_position_button_cb */


void installer_commands_form_enable_limits_button_cb(FL_OBJECT *ob, long data)
{
int temp[]={0xe0, 0x31, 0x6a, 0x00};

send_diseqc_command(temp, 4);

} /* end function installer_commands_form_enable_limits_button_cb */


void installer_commands_form_close_button_cb(FL_OBJECT *ob, long data)
{
fl_hide_form(fdui -> installer_commands_form);

} /* end function installer_commands_form_close_button_cb */


